sampler  mDiffuseSampler;
float fTime;			  // Time parameter. This keeps increasing

struct PS_INPUT
{
	float4 Color     : COLOR0;
	float2 Texture   : TEXCOORD0;
};

struct PS_OUTPUT
{
    float4 Color    : COLOR0;     // vertex diffuse color
};

PS_OUTPUT LabWall( in PS_INPUT p)
{
	PS_OUTPUT Output;
	Output.Color = tex2D( mDiffuseSampler, p.Texture );
	
	if(Output.Color.r < 0.25f && Output.Color.g < 0.25f && Output.Color.b < 0.25f)
	{
	   Output.Color.r = sin((p.Texture.x * 360.0f + fTime) * 3.1415f / 360.0f);
	   Output.Color.g = cos((p.Texture.y * 360.0f + fTime) * 3.1415f / 360.0f);
	}
	
	{
		Output.Color = Output.Color * p.Color;
	}
	
    return Output;
}

PS_OUTPUT LabWall2( in PS_INPUT p)
{
	PS_OUTPUT Output;
	Output.Color = tex2D( mDiffuseSampler, p.Texture );
	
	if(Output.Color.r < 0.1f && Output.Color.g < 0.1f && Output.Color.b < 0.1f)
	{
	   Output.Color.r = 0.8f * sin((p.Texture.x * 360.0f + fTime) * 3.1415f / 360.0f);
	   Output.Color.g = 0.8f * cos((p.Texture.y * 360.0f + fTime) * 3.1415f / 360.0f);
	   Output.Color.b = 0.9f;
	}
	
	{
		Output.Color = Output.Color * p.Color;
	}
	
    return Output;
}

PS_OUTPUT Barrier( in PS_INPUT p)
{
	PS_OUTPUT Output;
	Output.Color = tex2D( mDiffuseSampler, p.Texture );
	
	{
	   Output.Color.r = max(Output.Color.r,1.0f * cos((p.Texture.y * 540.0f + fTime * 7) * 3.1415f / 360.0f));
	   Output.Color.g = max(Output.Color.g,1.0f * cos((p.Texture.y * 540.0f + fTime * 7) * 3.1415f / 360.0f));
	   Output.Color.b = max(Output.Color.b,0.5 + 0.5f * cos((p.Texture.y * 540.0f + fTime * 7) * 3.1415f / 360.0f));
	}

	if(Output.Color.b < 0.75)
		Output.Color.a = 0.5f;
	
	{
		Output.Color = Output.Color * p.Color;
	}
	
    return Output;
}

PS_OUTPUT DatabaseSpace( in PS_INPUT p)
{
	PS_OUTPUT Output;
	Output.Color = tex2D( mDiffuseSampler, p.Texture );
	
	if(Output.Color.r > 0.6f && Output.Color.g > 0.6f && Output.Color.b > 0.6f)
	{
	   Output.Color.r = 0.3f + (Output.Color.r - 0.3f) * sin((p.Texture.x * 720.0f + fTime * 5) * 3.1415f / 360.0f);
	   Output.Color.b = 0.3f + (Output.Color.b - 0.3f) * cos((p.Texture.y * 720.0f + fTime * 5) * 3.1415f / 360.0f);
	}
	
	{
		Output.Color = Output.Color * p.Color;
	}
	
    return Output;
}

PS_OUTPUT Water( in PS_INPUT p)
{
	PS_OUTPUT Output;
	Output.Color = tex2D( mDiffuseSampler, p.Texture );
	
	Output.Color.a = 0.6f;

	if(Output.Color.r > 0.75f && Output.Color.g > 0.75f)
	{
	   Output.Color.b = sin((p.Texture.x * 360.0f + fTime) * 3.1415f / 360.0f);
	}
	
    return Output;
}